import json
import pytest
from pathlib import Path

import opa_tools.config
from opa_tools.request.retrieval import get_request


@pytest.fixture(scope="session")
def monkeysession():
    with pytest.MonkeyPatch.context() as mp:
        yield mp

@pytest.fixture(scope="session")
def request_dir(tmpdir_factory, monkeysession):
    tmpdir = tmpdir_factory.mktemp("data")
    monkeysession.setattr(opa_tools.config, "get_request_dir", tmpdir)
    with open("requests_testdata.json", "r") as rf:
        json_requests = json.load(rf)
    for relpath, request in json_requests.items():
        Path(tmpdir / relpath).parent.mkdir(parents=True, exist_ok=True)
        with open(tmpdir / relpath, "w") as wf:
            wf.write(request)

def test_get_request(request_dir):
    pass


# ALTERNATIVELY,
# def test_get_request(monkeypatch, tmpdir):
#     def request_dir():
#         with open("requests_testdata.json", "r") as rf:
#             json_requests = json.load(rf)
#         for relpath, request, in json_requests.items():
#             with open(tmpdir / relpath, "w") as wf:
#                 wf.write(request)
#     monkeypatch.setattr(opa_tools.config, "get_request_dir", request_dir)
#     pass
